
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>时间子系统12_clockevent设备注册 / iVAN</title>

    <meta name="description" content="时间子系统12_clockevent设备注册 // 向系统注册时钟事件设备 // 函数任务: // 1.添加设备到clockevent_devices链表 // 2.通知tick device管理机制有clockevent设备注册 1.1 void clockevents_register_device(struct clock_event_device *dev) { unsigned long flags; raw_spin_lock_irqsave(&amp;clockevents_lock, flags); //将设备添加到cloc ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">时间子系统12_clockevent设备注册</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<pre>//	向系统注册时钟事件设备
//	函数任务：
//		1.添加设备到clockevent_devices链表
//		2.通知tick device管理机制有clockevent设备注册
1.1 void clockevents_register_device(struct clock_event_device *dev)
{
	unsigned long flags;

	raw_spin_lock_irqsave(&amp;clockevents_lock, flags);
	//将设备添加到clockevent_devices链表
	list_add(&amp;dev-&gt;list, &amp;clockevent_devices);
	//向系统通知有新设备注册
	clockevents_do_notify(CLOCK_EVT_NOTIFY_ADD, dev);
	raw_spin_unlock_irqrestore(&amp;clockevents_lock, flags);
}

//	clockevent设备注册处理函数
//	调用路径：tick_notify-&gt;CLOCK_EVT_NOTIFY_ADD
//	函数任务：
//		1.确认设备服务于本cpu
//		2.如果设备非本cpu的local device
//			2.1 设置cpu的irq亲和性
//			2.2 如果本cpu已经绑定一个local device，并且二者服务的cpu相同，则忽略
//		3.如果本cpu已有local device，选择两者中更好的
//			3.1 优先选择支持单触发的
//			3.2 然后选择高rating的
//		4.如果本cpu使用的clockevent设备为广播设备，直接关闭
//		5.更新cpu的tick device为新tick device
//		6.启动tick device
//		7.异步通知周期时钟关于时钟事件设备的改变

//	注：如果不能设置为本cpu tick device的事件源，考虑其是否可以作为广播设备。
1.2 static int tick_check_new_device(struct clock_event_device *newdev)
{
	struct clock_event_device *curdev;
	struct tick_device *td;
	int cpu, ret = NOTIFY_OK;
	unsigned long flags;

	raw_spin_lock_irqsave(&amp;tick_device_lock, flags);
	//检查设备是否服务于本cpu
	cpu = smp_processor_id();
	if (!cpumask_test_cpu(cpu, newdev-&gt;cpumask))
		goto out_bc;
	//当前cpu的tick_device
	td = &amp;per_cpu(tick_cpu_device, cpu);
	curdev = td-&gt;evtdev;
	//检查是否为本cpu的local device
	//	如果设备只服务于本cpu，则为local device
	if (!cpumask_equal(newdev-&gt;cpumask, cpumask_of(cpu))) {

		//非local device，并且不能设置irq 亲和性，忽略
		if (!irq_can_set_affinity(newdev-&gt;irq))
			goto out_bc;
		//如果本cpu已经绑定有一个local device，则忽略
		if (curdev &amp;&amp; cpumask_equal(curdev-&gt;cpumask, cpumask_of(cpu)))
			goto out_bc;
	}
	//本cpu已有一个tick device
	if (curdev) {
		//选择两者中最好的tick device
		//优先选择 支持单触发模式
		if ((curdev-&gt;features &amp; CLOCK_EVT_FEAT_ONESHOT) &amp;&amp;
		    !(newdev-&gt;features &amp; CLOCK_EVT_FEAT_ONESHOT))
			goto out_bc;
		//然后选择 高rating
		if (curdev-&gt;rating &gt;= newdev-&gt;rating)
			goto out_bc;
	}

	//如果当前使用的clockevent设备为广播设备，直接关闭
	if (tick_is_broadcast_device(curdev)) {
		clockevents_shutdown(curdev);
		curdev = NULL;
	}
	//设置cpu的tick device为新tick device
	clockevents_exchange_device(curdev, newdev);
	//启动tick device
	tick_setup_device(td, newdev, cpu, cpumask_of(cpu));
	//异步通知周期时钟关于时钟事件设备的改变
	if (newdev-&gt;features &amp; CLOCK_EVT_FEAT_ONESHOT)
		tick_oneshot_notify();

	raw_spin_unlock_irqrestore(&amp;tick_device_lock, flags);
	return NOTIFY_STOP;

out_bc:
	//尝试设置clockevent设备为tick device
	if (tick_check_broadcast_device(newdev))
		ret = NOTIFY_STOP;
	raw_spin_unlock_irqrestore(&amp;tick_device_lock, flags);

	return ret;
}

//	绑定tick device到clockevnet设备
//	函数任务：
//		1.tick device未绑定过clockevent
//			1.1 选择cpu负责更新全局时间
//			1.2 以周期模式启动
//		2.tick device绑定过clockevnet
//			2.1 暂时设置其eventhandler=noop，保留下次到期时间
//		3.绑定tick device到新clockevent
//		4.clockevent并不仅服务于本cpu，设置irq亲和本cpu
//		5.如果设备没有正常工作，将设备加入广播组，然后退出
//		6.否则更新clockevent的事件处理函数
//			6.1 首次绑定，以周期模式启动
//			6.2 否则按照之前的模式启动
//	调用路径：tick_check_new_device-&gt;tick_setup_device

//	注：
//		1.由负责更新全局时间的cpu，初始化tick_next_period，tick_period
//			tick_next_period, 周期时钟下次到期的时间
//			tick_period，周期时钟的周期，1HZ经历的纳秒
1.2 static void tick_setup_device(struct tick_device *td,
			      struct clock_event_device *newdev, int cpu,
			      const struct cpumask *cpumask)
{
	ktime_t next_event;
	void (*handler)(struct clock_event_device *) = NULL;
	//tick device第一次创建，没有绑定clockevent
	if (!td-&gt;evtdev) {
		//如果没有cpu负责do_timer，由本cpu负责
		if (tick_do_timer_cpu == TICK_DO_TIMER_BOOT) {
			tick_do_timer_cpu = cpu;
			tick_next_period = ktime_get();
			tick_period = ktime_set(0, NSEC_PER_SEC / HZ);
		}
		//以周期模式启动
		td-&gt;mode = TICKDEV_MODE_PERIODIC;
	} else {
		//tick device非第一次创建，此次为更新clockevent
		//更新event处理函数为noop
		handler = td-&gt;evtdev-&gt;event_handler;
		next_event = td-&gt;evtdev-&gt;next_event;
		td-&gt;evtdev-&gt;event_handler = clockevents_handle_noop;
	}
	//更新tick device的clockevent
	td-&gt;evtdev = newdev;
	//clockevent并不仅服务于本cpu，设置irq与本cpu亲和
	if (!cpumask_equal(newdev-&gt;cpumask, cpumask))
		irq_set_affinity(newdev-&gt;irq, cpumask);

	//如果设备没有正常工作，将设备加入广播组，然后退出
	if (tick_device_uses_broadcast(newdev, cpu))
		return;
	//设置clockevent的eventhandler
	if (td-&gt;mode == TICKDEV_MODE_PERIODIC)
	{
		//以周期模式启动
		tick_setup_periodic(newdev, 0);
	}
	else
	{
		//以单触发模式启动
		tick_setup_oneshot(newdev, handler, next_event);
	}

} 

//	周期模式启动设备
//	调用路径：tick_check_new_device-&gt;tick_setup_device-&gt;tick_setup_periodic
//	函数任务：
//		1.设置设备周期处理函数
//		2.根据设备支持的模式，激活设备
//			2.1 如果设备支持周期模式，并且为激活单触发模式
//				2.1.1 设置设备当前为周期模式，退出
//				2.1.2 由周期处理函数执行周期任务
//			2.2 否则，通过单触发模式模拟周期运行
//				2.2.1 获取下次tick到期的时间
//				2.2.2 编程设备下一次到期时间
//				2.2.3 由周期处理函数执行周期任务，更新下次到期时间
1.3 void tick_setup_periodic(struct clock_event_device *dev, int broadcast)
{
	//设置clockevent的周期处理函数
	tick_set_periodic_handler(dev, broadcast);

	//设备不能正常启动，则有可能broadcast代其运行
	if (!tick_device_is_functional(dev))
		return;
	//如果设备支持周期模式，并且没有激活单触发模式
	if ((dev-&gt;features &amp; CLOCK_EVT_FEAT_PERIODIC) &amp;&amp;
	    !tick_broadcast_oneshot_active())
	{
		//设置设备为周期模式
		clockevents_set_mode(dev, CLOCK_EVT_MODE_PERIODIC);
	} else
	{

		unsigned long seq;
		ktime_t next;
		//获取下次tick到期的时间
		do {
			seq = read_seqbegin(&amp;xtime_lock);
			next = tick_next_period;
		} while (read_seqretry(&amp;xtime_lock, seq));
		//设置设备为单触发模式
		clockevents_set_mode(dev, CLOCK_EVT_MODE_ONESHOT);
		//设置设备下一次到期时间
		for (;;) {
			if (!clockevents_program_event(dev, next, ktime_get()))
				return;
			next = ktime_add(next, tick_period);
		}
	}
}
//	单触发模式启动设备
//	调用路径：tick_check_new_device-&gt;tick_setup_device-&gt;tick_setup_oneshot
//	函数任务：
//		1.设置事件处理函数
//		2.设置设备当前为单触发模式
//		3.更新设备事件的到期时间
1.4 void tick_setup_oneshot(struct clock_event_device *newdev,
			void (*handler)(struct clock_event_device *),
			ktime_t next_event)
{
	//设置事件处理函数
	newdev-&gt;event_handler = handler;
	clockevents_set_mode(newdev, CLOCK_EVT_MODE_ONESHOT);
	//更新设备事件到期时间
	tick_dev_program_event(newdev, next_event, 1);
}

//	设置设备为广播设备
//	函数任务：
//		1.成为广播设备的条件
//			1.1 设备不受电源状态的影响
//			1.2 设备的rating高于当前使用的广播设备
//		2.绑定此设备到全局广播设备
//		3.如果有设备被代理
//			3.1 开启广播设备
2.1 int tick_check_broadcast_device(struct clock_event_device *dev)
{
	//检查是否可以作为广播设备
	if ((tick_broadcast_device.evtdev &amp;&amp;
	     tick_broadcast_device.evtdev-&gt;rating &gt;= dev-&gt;rating) ||
	     (dev-&gt;features &amp; CLOCK_EVT_FEAT_C3STOP))
		return 0;

	clockevents_exchange_device(NULL, dev);
	tick_broadcast_device.evtdev = dev;
	//有设备需要被广播设备代理
	if (!cpumask_empty(tick_get_broadcast_mask()))
	{
		//启动广播设备
		tick_broadcast_start_periodic(dev);
	}
	return 1;
}
//	开启广播设备
//	函数任务：
//		1.设置广播设备的事件处理函数
//		2.编程启动广播设备
//	调用路径：tick_check_new_device-&gt;tick_broadcast_start_periodic
2.2 static void tick_broadcast_start_periodic(struct clock_event_device *bc)
{
	if (bc)
		tick_setup_periodic(bc, 1);
}

//	将cpu加入广播组
//	函数任务：
//		1.如果cpu的tick device没有正常工作
//			1.1 设置tick device的事件处理函数为周期事件处理函数
//			1.2 将设备加入广播组
//			1.3 启动广播设备
//		2.否则，如果设备不受省电模式C3的影响
//			2.1 将cpu从广播组中删除
3.1 int tick_device_uses_broadcast(struct clock_event_device *dev, int cpu)
{
	unsigned long flags;
	int ret = 0;

	raw_spin_lock_irqsave(&amp;tick_broadcast_lock, flags);

	if (!tick_device_is_functional(dev)) {
		dev-&gt;event_handler = tick_handle_periodic;
		cpumask_set_cpu(cpu, tick_get_broadcast_mask());
		tick_broadcast_start_periodic(tick_broadcast_device.evtdev);
		ret = 1;
	} else {
		//如果本设备不受省电模式C3的影响
		if (!(dev-&gt;features &amp; CLOCK_EVT_FEAT_C3STOP)) {
			int cpu = smp_processor_id();
			//将cpu从广播组中删除
			cpumask_clear_cpu(cpu, tick_get_broadcast_mask());
			tick_broadcast_clear_oneshot(cpu);
		}
	}
	raw_spin_unlock_irqrestore(&amp;tick_broadcast_lock, flags);
	return ret;
}
</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 09:29:27</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>时间子系统12_clockevent设备注册的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrWdKjp.html" rel="bookmark">时间子系统2&lowbar;tick device管理机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				// 1.每个cpu都具有一个tick_device,维护周期时钟. // 2.tick_device依赖一个clockevent设备,提供周期事件. // 3.cpu电源状态的改变会影响tick_device,通过tick_notifier监听电源状态. // 4.全局广播设备接管进入省电模式cpu的周期时间维护. // 4.broadcast_mask保存开启广播模式的cpu, broadcast_oneshot_mask保存进入省电模式的cpu. // 监听clockevent设备状态 /			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zea27Vz.html" rel="bookmark">Linux时间子系统之八：动态时钟框架（CONFIG&lowbar;NO&lowbar;HZ、tickless）【转】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自:http://blog.csdn.net/droidphone/article/details/8112948 版权声明:本文为博主原创文章,未经博主允许不得转载.   目录(?)[-] 数据结构 低分辨率下的动态时钟 1  切换至动态时钟模式 2  低分辨率动态时钟下的事件中断处理函数 3  动态时钟停止周期tick时钟事件 3  动态时钟重新开启周期tick时钟事件 高精度模式下的动态时钟 动态时钟对中断的影响   在前面章节的讨论中,我们一直基于一个假设:Linux中的时钟事件都是由			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6Ng8YM.html" rel="bookmark">虚拟化-Xenbus设备注册实现过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Xenbus设备注册实现过程 我想要实现自定义一个虚拟设备,注册到Xenbus上,过程包括将设备写入Xenstore,将设备注册到Xenbus,将设备驱动注册到Xenbus,实现前后端驱动连接. 在追踪代码的工程中,始终无法理解Xenbus是如何实现设备注册的?是Xenbus检测到Xenstore上存在该设备就去自动执行注册函数吗?还是在设备文件中执行注册? 非常感谢您的指导! 解决方案 驱动的注册过程和设备的注册过程(转载)设备驱动注册过程PowerPC平台,norflash及nan			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z76kRZp.html" rel="bookmark">Linux时间子系统之七：定时器的应用--msleep&lpar;&rpar;，hrtimer&lowbar;nanosleep&lpar;&rpar;【转】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  转自:http://blog.csdn.net/droidphone/article/details/8104433 我们已经在前面几章介绍了低分辨率定时器和高精度定时器的实现原理,内核为了方便其它子系统,在时间子系统中提供了一些用于延时或调度的API,例如msleep,hrtimer_nanosleep等等,这些API基于低分辨率定时器或高精度定时器来实现,本章的内容就是讨论这些方便.好用的API是如何利用定时器系统来完成所需的功能的. /*************************			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zeaZXxz.html" rel="bookmark">I&period;MX6 sdio 设备注册及识别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				/************************************************************************* * I.MX6 sdio 设备注册及识别 * 说明: * 大多数时候如果驱动都识别不到硬件设备,这就很艰难了,能识别到设备, * 后续才有得发挥. * * 2016-6-12 深圳 南山平山村 曾剑锋 ************************************************************************/			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdEBY6z.html" rel="bookmark">时间子系统17&lowbar;hard lockup机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				// 使能hard lockup探测 // 调用路径:watchdog_enable-&gt;watchdog_nmi_enable // 函数任务: // 1.初始化hard lockup检测事件 // 2.hard lockup阈值为10s // 2.向performance monitoring子系统注册hard lockup检测事件 // 3.使能hard lockup检测事件 // 注: // performance monitoring,x86中的硬件设备,当cpu clock经过了指定个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z72lQdp.html" rel="bookmark">网络子系统5&lowbar;设备队列规则</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				// 1.设备描述符与队列规则相关的字段: // 1.1 dev-&gt;tx_queue_len 指示驱动程序规则队列的队列长度,在注册设备时使用,通知核心是否为设备提供队列规则机制. // 1.1.1 不适用队列规则=0 // 1.1.2 使用队列规则&gt;0 // 1.2 dev-&gt;qdisc,执行设备传输时,qdisc_run,dev_queue_xmit始终通过该字段获取设备当前使用的队列规则. // 1.3 dev-&gt;qdisc_sleep, 保存设备具备传输能力时,使用的设备队			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlK4eRb.html" rel="bookmark">时间子系统10&lowbar;hpet时钟初始化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				// 时钟mult :mult/2^shift = ns/cyc // 参考:http://www.bluezd.info/archives/reg_clock_event_device_1 // x86平台初始化 // 注:arch/x86/kernel/x86_init.c 1.1 struct x86_init_ops x86_init __initdata = { ... //时钟初始化 .timers = { .setup_percpu_clockev = setup_boot_API			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pX2PdQb.html" rel="bookmark">Linux时间子系统之一：clock source（时钟源）【转】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自:http://blog.csdn.net/droidphone/article/details/7975694 clock source用于为linux内核提供一个时间基线,如果你用linux的date命令获取当前时间,内核会读取当前的clock source,转换并返回合适的时间单位给用户空间.在硬件层,它通常实现为一个由固定时钟频率驱动的计数器,计数器只能单调地增加,直到溢出为止.时钟源是内核计时的基础,系统启动时,内核通过硬件RTC获得当前时间,在这以后,在大多数情况下,内核通过选定			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zex1jp.html" rel="bookmark" class="title">技巧篇&mdash;&mdash;关键词堆砌没你想的那么简单</a>
					<div>
						我们都知道SEO的手段其中重要之一就是在网页中关键词堆砌,这点想接触SEO的人应该都有这样的潜意识,但是关键词堆砌却往往没有你想象的那么简单!我不知道哦是不是很多站长都有过我已经堆砌了关键词,但是往往 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LpdPK1p.html" rel="bookmark" class="title">图文解析SQL Server 2005与2000兼容性</a>
					<div>
						看来,你已经决定要从SQL Server 2000升级到SQL 2005了. 你可能已经在你的桌面电脑和测试环境中安装了一个SQL Server 2000的实例并想要进行适当的升级.或者你可能只是想安 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zGNDOp.html" rel="bookmark" class="title">建站经验分享：3000独立IP，每天10美元</a>
					<div>
						和大家说说我的网赚经验,我的ip不是很高,就不公布我的站了(避免广告嫌疑),挣得的钱也不是很多,但是租服务器的钱是没有问题的,还有点小小的外块.  先说说我的建站经历吧,2002年开始建站,那个时候正 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp53q6b.html" rel="bookmark" class="title">在VB组件中使用串缓冲 - 2</a>
					<div>
						Lesson 2 : The VB Component ------------------------------------------------------------------------ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2yVjoz.html" rel="bookmark" class="title">Android Service生命周期及用法</a>
					<div>
						上一节我讲解了Android Activity的生命周期,这一节我将讲解一下Service,首先我们要知道Service具体是干什么的,什么时候用到?以及它的生命周期等. Service概念及用途:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKe4Vp.html" rel="bookmark" class="title">Geronimo renegade&colon; OpenEJB和Apache Geronimo的EJB实现</a>
					<div>
						Enterprise JavaBeans (EJBs) 到底有什么了不起的,为什么对 Java 2 Platform, Enterprise Edition (J2EE) 开发来说如此重要?在这一期的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPdnwz.html" rel="bookmark" class="title">WPS中Excel怎么安装使用宏插件&quest;</a>
					<div>
						  WPS中Excel怎么安装使用宏插件?          1.默认的WPS Excel中的&quot;宏&quot;是灰色关闭状态,我们可以清楚的看到&quot;宏&quot;的功能是没有启用的( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGjdDop.html" rel="bookmark" class="title">win7系统360浏览器收藏夹怎么删除不常用的网站</a>
					<div>
						win7系统360浏览器收藏夹怎么删除不常用的网站            1.打开360浏览器进入主界面,点击[浏览器图标]; 2.在弹出的对话框中,点击[登录账号]; 3.进入登录界面,输入360账 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRyWR8b.html" rel="bookmark" class="title">Excel表格设置页眉页脚动画教程</a>
					<div>
						&lt;Excel2003入门动画教程17.Excel表格设置页眉页脚&gt;. 演示动画 操作步骤 添加页眉:打开需要添加页眉页脚的Excel表格,执行&quot;文件→页面设置&quot;命令,打 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDA1R0b.html" rel="bookmark" class="title">Ubuntu系统上使用LVM调整硬盘分区的教程</a>
					<div>
						  先来介绍一下硬盘分区的基本知识: 物理介质 The physical media 你应该感受&quot;物理&quot;这个单词有极大的延伸,虽然我们刚开始假设它仅仅是一个硬盘,或者一个分区.例如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNwNmb.html" rel="bookmark" class="title">Word2010不保存最近浏览文档，保护隐私</a>
					<div>
						每次我们打开word文档之后,word文档就会自动保存最近浏览文档记录.在哪里可以设置word文档不保存最近浏览文档记录呢? 难度:初级 步骤方法 第一步:打开word文档,点击文件,打开高级.在高级 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5A1nWp.html" rel="bookmark" class="title">win7 删除用户账户的方法</a>
					<div>
						  步骤一.鼠标点击桌面右下角的&quot;开始菜单--控制面板&quot;,找到控制面板中的&quot;用户账户&quot;,在点击打开用户账户.如图所示: 步骤二.在用户账户窗口上面只显示出管理员 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBg4nz.html" rel="bookmark" class="title">word 2013中如何绘制笑脸</a>
					<div>
						  我们先看一下我们要达到的目标图,先有一个整体的映像. 其实,我们知道中间的笑脸不难画,难点在笑脸外围的细长椭圆,我们数一下有24个. 先画一个椭圆:插入→形状→流程图→椭圆 填充颜色 笑脸外围有2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGZWNp.html" rel="bookmark" class="title">eclipse-安装SDK后下载不了安装包</a>
					<div>
						问题描述 安装SDK后下载不了安装包 我用的是eclipse,安装好了JDK和配置了环境变量.下载好了SDK,运行,下载安装包,发现报错.于是在网上查了些方法,跟着上面说的方法弄.在system32, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXw03KM.html" rel="bookmark" class="title">【转载】MySQL 之临时表和内存表</a>
					<div>
						      今天(2013-10-17)又看了一篇很久以前的博客文章,题目是&lt; How to eliminate temporary tables in MySQL &gt;,里面的一些观点和结 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bamvEPb.html" rel="bookmark" class="title">配置-maven从镜像仓库中下载后存入到私服仓库上</a>
					<div>
						问题描述 maven从镜像仓库中下载后存入到私服仓库上 maven 上我设置一个镜像仓库后, 从镜像仓库中下载的jar, 能不能还能存入到本地的私服上, 能的话是怎样进行配置的 解决方案 我觉得,对于 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmXr8z.html" rel="bookmark" class="title">javascript 客户端验证上传图片的大小（兼容IE和火狐）&lowbar;javascript技巧</a>
					<div>
						在我 上一篇帖子 (译文 ) 中,谈到了各个浏览器究竟会在什么情况下弹出脚本失控提示,对于Internet Explorer 来说,当浏览器执行了数量过多的语句时就会停止执行脚本,而其他的浏览器,则是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Q9d8p.html" rel="bookmark" class="title">网络取证原理与实战</a>
					<div>
						原创作品,允许转载,转载时请务必以超链接形式标明文章 原始出处 .作者信息和本声明.否则将追究法律责任.http://chenguang.blog.51cto.com/350944/1660017   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1lnl9b.html" rel="bookmark" class="title">蓝桥杯 历届试题 大臣的旅费</a>
					<div>
						历届试题 大臣的旅费   时间限制:1.0s   内存限制:256.0MB        问题描述 很久以前,T王国空前繁荣.为了更好地管理国家,王国修建了大量的快速路,用于连接首都和王国内的各大城市 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPGN8p.html" rel="bookmark" class="title">VC文档 视图 框架窗口间的关系和消息传送规律</a>
					<div>
						文档 视图 框架窗口间的关系和消息传送规律在MFC中M$引入了文档-视结构的概念,文档相当于数据容器,视相当于查看数据的窗口或是和数据发生交互的窗口.(这一结构在MFC中的OLE,ODBC开发时又得到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9YZZRM.html" rel="bookmark" class="title">数据可视化监控疑问&period;&period;&period;&period;&period;&period;</a>
					<div>
						问题描述 数据可视化监控疑问...... java业务数据可视化监控中心使用的技术和框架,在地图上展示实时业务数据					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2PjQvp.html" rel="bookmark" class="title">腾讯动漫爬虫与动态随机加载反爬破解技术实战</a>
					<div>
						​​本文作者韦玮原创,转载请注明出处. 项目需求与问题引入 有时,我们想爬取腾讯动漫中的漫画,比如,我们不妨打开腾讯动漫中某一个动漫的网址http://ac.qq.com/Comic/comicInf ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7ZxLZp.html" rel="bookmark" class="title">转型-Java中数组的类型转换问题</a>
					<div>
						问题描述 Java中数组的类型转换问题 向上转型自不用说,对向下转型原理也知道,主要看父类的引用:如果父类变量引用的是正确的子类类型(即父类对象引用的是子类型的内存空间,然后赋给子类对象),则赋值将执 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwW3vvz.html" rel="bookmark" class="title">（ICCAVR中编译的）ATmega16程序与对应的proteus仿真图</a>
					<div>
						问题描述 (ICCAVR中编译的)ATmega16程序与对应的proteus仿真图 有没有人做(ICCAVR中编译的)ATmega16的AD转换.T/C1捕获.通用串行接口DUART.TWI.矩阵这样 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRlVOb.html" rel="bookmark" class="title">网络简化为云计算带来的便利</a>
					<div>
						企业和消费者都希望能够随时随地,通过任何设备实现更多.更快.更丰富的内容与服务交付.以上的功能和需求能够通过云计算得到满足,但前提是需要数据中心能够克服网络设计中所存在的挑战. 为何网络复杂性特别重要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlL37DM.html" rel="bookmark" class="title">oracle等待事件4&mdash;&mdash;buffer busy wait 特别介绍</a>
					<div>
						  以下内容太整理自网络,完全处于学习目的,如有侵权请及时联系我,我会立即删除.   非空闲等待之:buffer busy waits 事件参数说明: 事件号 事件名 参数一 参数二 参数三 145  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba6laJM.html" rel="bookmark" class="title">软通动力积极筹备上市计划于2009年在境外IPO</a>
					<div>
						5月13日消息,中国IT外包服务提供商软通动力(iSoftStone)首席财务官武军日前透露,软通动力目前正在积极筹备上市,计划于&quot;2009年前后&quot;在境外IPO(首次公开招股).  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0NNj0z.html" rel="bookmark" class="title">PHP学习笔记（一）：基本语法之标记、空白、和注释&lowbar;php技巧</a>
					<div>
						一.PHP 标记 1.XML风格 复制代码 代码如下: &lt;?php echo &quot;hello world&quot;;?&gt; 2.简短风格 复制代码 代码如下: &lt;? echo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKqd2Ep.html" rel="bookmark" class="title">快速掌握Android开发中Touch事件分发机制</a>
					<div>
						Touch事件分发中只有两个主角:ViewGroup和View.Activity的Touch事件事实上是调用它内部的ViewGroup的Touch事件,可以直接当成ViewGroup处理. View在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJejwJp.html" rel="bookmark" class="title">纳德拉：Windows Phone市场份额虽低 但它&OpenCurlyDoubleQuote;完整了体验&rdquo;</a>
					<div>
						Windows 10 Mobile和Windows Phone 8.1的市场份额都非常低,就连微软现任CEO萨蒂亚·纳德拉都承认.但其也争辩称,Windows Phone的存在仍有必要,因为它完整了体 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
